/*
  This is AppShed Free AP sketch based on the aREST Library written by
  Marco Schwartz. This sketch is based on the aREST example "ESP SoftAP"

  This is the sketch you use when you want to create a local network with
  the Node, if you want to create a cloud project use the AppShed Free Cloud
  sketch on AppSheds Github page.

  If you would like to learn more about the aREST library check out the aREST
  examples and their comments.

  V.1 - 14/5/2020
*/

// 1 The required libraries
#include <ESP8266WiFi.h>
#include <aREST.h>
aREST rest = aREST();

// 2 Set your desired WIFI name and Password
const char* ssid = "AppShedIoT";
const char* password = "appshedrocks";

#define LISTEN_PORT           80
WiFiServer server(LISTEN_PORT);
int ledControl(String command);

 // 3 The Setup
void setup(void)
{
  // 4 Start Serial at 115200
  Serial.begin(115200);
  
  rest.function("led",ledControl);
  rest.set_id("1");
  rest.set_name("esp8266");
  WiFi.softAP(ssid, password);
  Serial.println("");
  Serial.println("WiFi created");
  server.begin();
  Serial.println("Server started");
  IPAddress myIP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(myIP);

}

// 5 The Loop (try not to delay the loop)
void loop() {

  WiFiClient client = server.available();
  if (!client) {
    return;
  }
  while(!client.available()){
    delay(1);
  }
  rest.handle(client);

}

int ledControl(String command) {

  int state = command.toInt();

  digitalWrite(6,state);
  return 1;
}
